/*****************************************************************************/
/*                             WiNRADiO G66WSB                               */
/*                                SDK DEMO                                   */
/*             Receiver selection and "No receiver found" dialogs            */
/*                        (c) Copyright RADIXON 2025                         */
/*****************************************************************************/

#ifndef __U_RECEIVERSELECTOR_H__
#define __U_RECEIVERSELECTOR_H__

#include <wx/wx.h>
#include <wx/listctrl.h>
#include "g66wsbapi.h"

//TReceiverSelector window appears when more than one receivers are detected
//the user can select one of them
class TReceiverSelector:public wxDialog
{
public:
    static IG66WSBDevice* SelectReceiver(void);

    inline int GetSelectedReceiverIndex(void) const
    {
        return m_SelectedReceiverIndex;
    }

    TReceiverSelector(IG66WSBDeviceEnumerator *Enumerator);
    ~TReceiverSelector(void);
private:
    wxRadioBox      *m_RadioBox;
    wxButton        *m_BOK;
    wxButton        *m_BCancel;
    int             m_SelectedReceiverIndex;

    void OnOk(wxCommandEvent &Event);

    DECLARE_EVENT_TABLE()
};

//TNoReceiverFoundWindow window appears when no receiver is detected
class TNoReceiverFoundWindow:public wxDialog
{
public:
    TNoReceiverFoundWindow(void);
    ~TNoReceiverFoundWindow(void);
private:
    wxButton    *m_BTryAgain;
    wxButton    *m_BDemo;
    wxButton    *m_BCancel;

    void OnTryAgain(wxCommandEvent &Event);
    void OnDemo(wxCommandEvent &Event);

    DECLARE_EVENT_TABLE()
};


#endif
