#ifndef __G66WSB_EXAMPLE_H__
#define __G66WSB_EXAMPLE_H__

#include "g66wsbapi.h"
#include <pulse/simple.h>

class TG66WSB:public IG66WSBDeviceCallback
{
public:
    enum
    {
	AUDIO_SAMPLE_RATE=64000,
    };

    bool LoadAPI(void);
    void UnloadAPI(void);

    bool Open(const char *DevicePath);

    inline bool OpenFirst(void)
    {
        //open the first available G66WSB receiver
        return Open(G66WSB_OPEN_FIRST);
    }

    inline bool OpenDemo(void)
    {
        //open demo G66WSB receiver
        return Open(G66WSB_OPEN_DEMO);
    }

    void Close(void);

    void StartStreaming(void);
    void StopStreaming(void);


    void OpenWaveOut(void);
    void CloseWaveOut(void);

    //methods of IG66WSBDeviceCallback callback interface
    void G66WSB_DDCStreamCallback(IG66WSBDevice *Device,uint32_t DDCId,const float *Buffer,uint32_t Count,float SlevelPeak,float SlevelRMS);
    void G66WSB_AudioStreamCallback(IG66WSBDevice *Device,uint32_t DDCId,uint32_t Stage,const float *Buffer,uint32_t Count);
    void G66WSB_ChannelActivityCallback(IG66WSBDevice *Device,const float *RMS,const float *dBm,uint16_t ADCLevel);

    TG66WSB(void);
    ~TG66WSB(void);
private:
    IG66WSBDevice               *m_Device;
    void                        *m_API;
    G66WSB_CREATE_INSTANCE      m_CreateInstance;
    pa_simple                   *m_PaSimple;
    uint32_t                    m_DDCId;
};

#endif
